#include "mazefunction.h"

/*

  The input argument is the number of command line arguments given
  when executing the file.  It checks to see if there are at least 2
  commandline arguments.  If yes , the function returns TRUE. if not,
  the function prints an error message by calling
  PrintError(NOFILENAME) and return FALSE 

*/
int CheckArgCount(int argc) 
{
  return 1;
}

/*

  The input arguments are a string as the name of a file and the
  option on how the function will manipulate the file (read, write,
  read and write, or append). This function opens the file and returns
  the FILE pointer.  If it fails to open the file, the function prints
  an error message by calling PrintError(FILEERROR) and returns NULL

*/

FILE * OpenFile(char fileName[], char opt[]) 
{
  return NULL;
}

/*
  
  This function prints the corrdinate of the starting point 's' by
  calling PrintResult(PRINTSTART, row, col) and returns.

  If the input maze file has no starting point, the function prints an
  error message by PrintError(NOSTARTEXIT) and returns.

  Hint: use fseek to set the file pointer to the beginning. Read the
  file one character at a time.  Meanwhile, keep track of the rows and
  columns.

*/
void FindStart(FILE *fptr) 
{
  fseek(fptr, 0, SEEK_SET); /* set the file point to the beginning */
}

/*

  This function prints the corrdinate of the exit 'E' by calling
  PrintResult(PRINTEXIT, row, col) and returns.

  If the input maze file has no exit, the function prints an error
  message by calling PrintError(NOSTARTEXIT) and returns.

*/

void FindExit(FILE *fptr) 
{
  fseek(fptr, 0, SEEK_SET); /* set the file point to the beginning */
}

/*

  This function checks whether a location is a brick '*'. The location
  is specified by row and column.

  If the location is a brick, It prints the row and column of the
  location by calling PrintResult(BRICK, row, col). If location is not
  a brick, the function prints nothing. 

  The input arguments are the row and the coloumn of a location and
  the file pointer. This function reads from the beginning of the file
  and checks whether at the specific location is a brick.

*/

void CheckBrick(FILE *fptr, int row, int col) 
{
  fseek(fptr, 0, SEEK_SET); /* set the file point to the beginning */
}

/*

  This function determins whether a location is inside a maze.
  The location is specified by row and column.

  If the location is within the maze (including the outermost bricks),
  the function prints the row and column of the point by calling
  PrintResult(BOUNDED, row, col). If this location is outside the
  maze, the function prints nothing.

  The input arguments are the row and the coloumn of a location and
  the file pointer. This function reads from the beginning of the file.

*/
void CheckBounded(FILE *fptr, int row, int col) 
{
  fseek(fptr, 0, SEEK_SET); /* set the file point to the beginning */
}

/*

  This function prints the size of a maze.
  
  The function start from the beginning of the file and computes the
  maximum row and col of the maze. The function prints the row and col
  by calling PrintResult(MAZESIZE, row, col). 

  Hint: all mazes are rectangular
*/

void FindMazeSize(FILE *fptr) 
{
  fseek(fptr, 0, SEEK_SET); /* set the file point to the beginning */
}

/*

  The input arguments are an integer representing the error message to
  be printed. This function prints out the error message.

*/
void PrintError(int error) 
{
  /* DO NOT MODIFY THIS FUNCTION */
  switch(error) 
    {
    case NOFILENAME:
      printf("Usage: ipa1-1 <maze file>\n");
      break;
    case FILEERROR:
      printf("Error opening file! Exiting Program!\n");
      break;
    case NOSTARTEXIT:
      printf("Maze is invalid due to a missing starting/exit point\n");
      break;
    default:
      break;
    }
  return;
}

/*

  The input arguments are an integer representing the result message
  to be printed. This function prints out the result message if called
  by the functions. 

*/
void PrintResult(int result, int row, int col) 
{
  /* DO NOT MODIFY THIS FUNCTION */
  switch(result) 
    {
    case PRINTSTART:
      printf("Start at (%3d,%3d)\n", row, col);
      break;
    case PRINTEXIT:
      printf("Exit at (%3d,%3d)\n", row, col);
      break;
    case BRICK:
      printf("(%3d,%3d) is a brick\n", row, col);
      break;
    case BOUNDED:
      printf("(%3d,%3d) is bounded\n", row, col);
      break;
    case MAZESIZE:
      printf("Maximum row is %3d, Maximum column is %3d\n", row, col);
      break;
    default:
      break;
    }
  return;
}

/*

  The input argument is the FILE pointer. This function closes the
  file and returns nothing

*/
void CloseFile(FILE* fptr) 
{
}
